module SsorokaHangmanPlayer_1
  class SsorokaHangmanPlayer_1
    def initialize
      @words = []
    end
    def word_list=(list)
      @list = list
      @words = list.sort.uniq.inject({}) {|sum, i| 
        sum[i.size] ||= []
        sum[i.size] << i
        sum
      }
    end
    def new_game(guesses_left)
      @left = %w(e a i r n t o l s c u p m d h y g b f v k w z x q j)
      @taken = ['0']
      @words_left = nil
    end
    def guess(word, guesses_left)
      re = my_regexp_guess(word)
      @words_left = @words[word.size].dup if !@words_left
      @words_left.reject!{|w| w !~ re }
      return @left.shift if @words_left.empty?
      pick_best_letter
    end
    def my_regexp_guess(word)
      Regexp.new(word.gsub('_', "[^#{@taken * ''}]"))
    end
    def pick_best_letter
      @words_left.inject({}) {|sum, w|
        w.split('').uniq.each{|l| sum[l] = (sum[l] || 0) + 1 }; sum
      }.select{|k,v| @left.include?(k)}.sort_by{|k,v| -v }.first[0]
    end
    def incorrect_guess(guess)
      @left.delete(guess)
      @taken.push(guess)
    end
    def correct_guess(guess)
      incorrect_guess(guess) # same thing.
    end
    def fail(reason);end
    def game_result(result, word);end
  end
end